divert(-1)
# format of table ispnames:
#user@host:maildrop	user2@host2
#			user2
#			%1@host2 # usually not recommended
#@host:maildrop		%1@host2 #      dito
#
#user2@host2:mailname	user@host
#                       %1@host
#user2:mailname		user@host
#			%1@host
# to enable outgoing mail for a user, he must mail with his outgoing account
# there must be a maildrop for this remote name and a mailname to 
# THIS looked up maildrop-account
#
#   `define(`_ALL_LOCAL2ISP_', `')dnl'
#
# depends on `HACK(canonifylocal)'
#            `HACK(smtpx)'
#

ifdef(`_smtpx_',,
	`errprint(`*** HACK(ispnamestable) depends on HACK(smtpx) ')')dnl

ifdef(`_CANONIFY_LOCAL_',,
	`errprint(`*** HACK(ispnamestable) depends on HACK(canonifylocal) ')')dnl

define(`ISPNAMES_TABLE', `ifelse(_ARG_, `', `hash -o /etc/ispnamestable', `_ARG_')')dnl

divert(0)
VERSIONID(`@(#)ispnamestable.m4	1.0 (Berkeley) 5/31/96')dnl

LOCAL_CONFIG
#table to map ISP-names to local accounts and vice-versa
Kispnames ISPNAMES_TABLE

LOCAL_RULE_0
#does rcpt also have a local maildrop?
dnl # R$+ <@ $+ .> 		$: < $(ispnames $1 @ $2:maildrop $@ $1 $: @ $) > $1 < @ $2 . >
R$+ <@ $+ > 		$: < $(ispnames $1 @ $2:maildrop $@ $1 $: @ $) > $1 < @ $2 > 
dnl # R<@> $+ <@ $+ .> 	$: < $(ispnames @ $2:maildrop $@ $1 $: @ $) > $1 < @ $2 . > 
R<@> $+ <@ $+ >		$: < $(ispnames @ $2:maildrop $@ $1 $: @ $) > $1 < @ $2 > 
R<@> $+			$: $1		not found, cleanup
R<error: $- $+ > $*	$#error $@ $( dequote $1 $) $: $2
R< $+ > $+ <@ $+ >	$: $>3 $1	yes, found. canonicalize 

LOCAL_RULESETS
####################################################
###  Ruleset start				 ###
###  fake for -bt mode. Use with                 ###
###        start,rule_to_test from_adr $| to_adr ###
####################################################

Sstart

R$* $$| $*		$: $1 $| $2

######################################################################
#subroutine from check_compat. call twice - it rotates sender $| rcpt#
######################################################################

Schk_isp_local

R$+ <@ $+ > $| $*		$: < $(ispnames $1 @ $2:maildrop $@ $1 $: @ $) > $1<@ $2> $| $3
R<@> $+ <@ $+ > $| $*		$: < $(ispnames @ $2:maildrop $@ $1 $: @ $) > $1<@ $2> $| $3
R<@> $+ $| $*			$: $2 $| $1		not found, cleanup
R< $+ > $+ <@ $+ > $| $*	$: $4 $| $>3 $1		found, canonicalize

Schk_can

R$* < @ $* > $*		$@ $1 < @ $2 > $3		already fully qualified
R$+			$@ $1 < @ *LOCAL* >		add local qualification

###################################################################
###  Ruleset check_compat 					###
###      -- is rcpt allowed to be reahed by sender		###
### called with "from_adr $| rcpt_to"                           ###
### if rcpt_to not in {NoSmart}, check if from_adr is valid     ###
###                                                             ###
### nonlocal mail is rejected, if from_adr isnt a valid ispname ###
### nonlocal mail is accepted for queing, reject is done on     ###
### queue-run                                                   ###
###################################################################

Scheck_compat

R$+ $| $+			$: $2 $| $>3 $1		canonicalize recipient
R$+ $| $+			$: $2 $| $>3 $1		canonicalize sender
R$+ $| $+			$: $2 $| $>chk_can $1
R$+ $| $+			$: $2 $| $>chk_can $1
R$+ $| $+ <@ $+ .> $*		$: $1 $| $2 <@ $3 > $4	remove trailing dot - rcpt
# now resolve rcpt and sender to maildrop (isp_local) 
R$+				$: $>chk_isp_local $1
R$+				$: $>chk_isp_local $1
R$+ $| $+			$: $2 $| $>chk_can $1
R$+ $| $+			$: $2 $| $>chk_can $1

# local traffic
R$+ $| $+ <@ *LOCAL* > $*	$@ok			to this machine
R$+ $| $+ <@ $+ . $={NoSmart} >	$@ok			to class NoSmart
R$+ $| $+ <@ $={NoSmart} >	$@ok			to class NoSmart
R$+ $| $+ <@ $- >		$@ok			to unqualified host
# right now all local traffic should be reported as ok
R$+ <@ $+ .> $| $*		$: $1 <@ $2 > $| $3	remove trailing dot - from

#does this sender have a mailname (local_isp)
R$+ <@*LOCAL*> $| $*		$: < $(ispnames $1@$j:mailname $@ $1 $: $) > $1 <@*LOCAL*> $| $2
R< > $+ <@*LOCAL*> $| $*	$: < $(ispnames $1:mailname $@ $1 $: $) > $1 <@*LOCAL*> $| $2
R $+ <@$j> $| $*		$: < $(ispnames $1:mailname $@ $1 $: $) > $1 <@*LOCAL*> $| $2
R< > $+ 			$: $1			not found, cleanup
R< $+ > $+ 			$@ok			lookup was successfull

R$+ <@ $j > $| $*		$: < $(ispnames $1:mailname $@ $1 $: $) > $1 <@*LOCAL*> $| $2
R< > $+ 			$: $1			not found, cleanup
R< $+ > $+ 			$@ok			lookup was successfull

R$+ <@ $+ > $| $*		$: < $(ispnames $1@$2:mailname $@ $1 $: $) > $1 <@ $2 > $| $3
# following line converts all user@any.hosts to ispnames if user is known
ifdef(`_ALL_LOCAL2ISP_', `', `#')dnl
R< > $+ <@ $+ > $| $*		$: < $(ispnames $1:mailname $@ $1 $: $) > $1 <@ $2> $| $3	
R< > $+ 			$: $1			not found, cleanup
R< $+ > $+ 			$@ok			lookup was successfull

# otherwise ...
R$*				$#error $@ 5.7.1 $: "551 remote traffic is denied to you"
# a message "Data format error" is also sent

